/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/



























#ifndef OPERATION_H
#define OPERATION_H
#include <stdio.h>
#include "object.h"
#include "node.h"

extern int check_type ();
extern int check_member ();
extern nodeType *parsefile (char **code);
extern nodeType *parseexpression (char *expression);

extern obj putinteger ();
extern obj putfloat ();
extern obj putstring ();
extern obj putchars ();
extern obj cleanstring (obj o);
extern obj addstring (obj o);
extern obj putconstidentifier ();
extern obj putidentifier ();
extern obj createidentifier ();
extern obj putcallbuiltin (obj o1);
extern obj putbuiltinfunction ();
extern obj putcallmember (obj o1);
extern obj putmember ();

extern nodeType *ActiveNode;
#endif 
