/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef MATHFCT_H
#define MATHFCT_H
#include "object.h"
#include "libfct.h"

extern obj vb_ABS (int narg, obj * arg);
extern obj vb_ACOS (int narg, obj * arg);
extern obj vb_ACOSH (int narg, obj * arg);
extern obj vb_ASIN (int narg, obj * arg);
extern obj vb_ASINH (int narg, obj * arg);
extern obj vb_ATAN (int narg, obj * arg);
extern obj vb_ATAN2 (int narg, obj * arg);
extern obj vb_ATANH (int narg, obj * arg);
extern obj vb_CEILING (int narg, obj * arg);
extern obj vb_COMBIN (int narg, obj * arg);
extern obj vb_COS (int narg, obj * arg);
extern obj vb_COSH (int narg, obj * arg);
extern obj vb_COUNTIF (int narg, obj * arg);
extern obj vb_DEGREES (int narg, obj * arg);
extern obj vb_EVEN (int narg, obj * arg);
extern obj vb_EXP (int narg, obj * arg);
extern obj vb_FACT (int narg, obj * arg);
extern obj vb_FACTDOUBLE (int narg, obj * arg);
extern obj vb_FLOOR (int narg, obj * arg);
extern obj vb_GCD (int narg, obj * arg);
extern obj vb_INT (int narg, obj * arg);
extern obj vb_LCM (int narg, obj * arg);
extern obj vb_LN (int narg, obj * arg);
extern obj vb_LOG (int narg, obj * arg);
extern obj vb_LOG10 (int narg, obj * arg);
extern obj vb_MDETERM (int narg, obj * arg);
extern obj vb_MINVERSE (int narg, obj * arg);
extern obj vb_MMULT (int narg, obj * arg);
extern obj vb_MOD (int narg, obj * arg);
extern obj vb_MROUND (int narg, obj * arg);
extern obj vb_MULTINOMIAL (int narg, obj * arg);
extern obj vb_ODD (int narg, obj * arg);
extern obj vb_PI (int narg, obj * arg);
extern obj vb_POWER (int narg, obj * arg);
extern obj vb_PRODUCT (int narg, obj * arg);
extern obj vb_QUOTIENT (int narg, obj * arg);
extern obj vb_RADIANS (int narg, obj * arg);
extern obj vb_RAND (int narg, obj * arg);
extern obj vb_RANDBETWEEN (int narg, obj * arg);
extern obj vb_ROMAN (int narg, obj * arg);
extern obj vb_ROUND (int narg, obj * arg);
extern obj vb_ROUNDDOWN (int narg, obj * arg);
extern obj vb_ROUNDUP (int narg, obj * arg);
extern obj vb_SERIESSUM (int narg, obj * arg);
extern obj vb_SIGN (int narg, obj * arg);
extern obj vb_SIN (int narg, obj * arg);
extern obj vb_SINH (int narg, obj * arg);
extern obj vb_SQRT (int narg, obj * arg);
extern obj vb_SQRTPI (int narg, obj * arg);
extern obj vb_SUM (int narg, obj * arg);
extern obj vb_SUMIF (int narg, obj * arg);
extern obj vb_SUMPRODUCT (int narg, obj * arg);
extern obj vb_SUMSQ (int narg, obj * arg);
extern obj vb_SUMX2MY2 (int narg, obj * arg);
extern obj vb_SUMX2PY2 (int narg, obj * arg);
extern obj vb_SUMXMY2 (int narg, obj * arg);
extern obj vb_TAN (int narg, obj * arg);
extern obj vb_TANH (int narg, obj * arg);
extern obj vb_TRUNC (int narg, obj * arg);
extern obj vb_print (int narg, obj * arg);
extern obj vb_repaint (int narg, obj * arg);
extern obj vb_shell (int narg, obj * arg);

extern Fct matharrayfct[];




#endif 
