/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef STATFCT_H
#define STATFCT_H
#include "object.h"
#include "libfct.h"


extern obj vb_AVEDEV (int narg, obj * arg);
extern obj vb_AVERAGE (int narg, obj * arg);
extern obj vb_BETADIST (int narg, obj * arg);
extern obj vb_BETAINV (int narg, obj * arg);
extern obj vb_BINOMDIST (int narg, obj * arg);
extern obj vb_CHIDIST (int narg, obj * arg);
extern obj vb_CHIINV (int narg, obj * arg);
extern obj vb_CHITEST (int narg, obj * arg);
extern obj vb_CONFIDENCE (int narg, obj * arg);
extern obj vb_CORREL (int narg, obj * arg);
extern obj vb_COUNT (int narg, obj * arg);
extern obj vb_COUNTA (int narg, obj * arg);
extern obj vb_COVAR (int narg, obj * arg);
extern obj vb_CRITBINOM (int narg, obj * arg);
extern obj vb_DEVSQ (int narg, obj * arg);
extern obj vb_EXPONDIST (int narg, obj * arg);
extern obj vb_FDIST (int narg, obj * arg);
extern obj vb_FINV (int narg, obj * arg);
extern obj vb_FISHER (int narg, obj * arg);
extern obj vb_FISHERINV (int narg, obj * arg);
extern obj vb_FORECAST (int narg, obj * arg);
extern obj vb_FREQUENCY (int narg, obj * arg);
extern obj vb_FTEST (int narg, obj * arg);
extern obj vb_GAMMADIST (int narg, obj * arg);
extern obj vb_GAMMAINV (int narg, obj * arg);
extern obj vb_GAMMALN (int narg, obj * arg);
extern obj vb_GEOMEAN (int narg, obj * arg);
extern obj vb_GROWTH (int narg, obj * arg);
extern obj vb_HARMEAN (int narg, obj * arg);
extern obj vb_HYPGEOMDIST (int narg, obj * arg);
extern obj vb_INTERCEPT (int narg, obj * arg);
extern obj vb_KURT (int narg, obj * arg);
extern obj vb_LARGE (int narg, obj * arg);
extern obj vb_LINEST (int narg, obj * arg);
extern obj vb_LOGEST (int narg, obj * arg);
extern obj vb_LOGINV (int narg, obj * arg);
extern obj vb_LOGNORMDIST (int narg, obj * arg);
extern obj vb_MAX (int narg, obj * arg);
extern obj vb_MEDIAN (int narg, obj * arg);
extern obj vb_MIN (int narg, obj * arg);
extern obj vb_MODE (int narg, obj * arg);
extern obj vb_NEGBINOMDIST (int narg, obj * arg);
extern obj vb_NORMDIST (int narg, obj * arg);
extern obj vb_NORMINV (int narg, obj * arg);
extern obj vb_NORMSDIST (int narg, obj * arg);
extern obj vb_NORMSINV (int narg, obj * arg);
extern obj vb_PEARSON (int narg, obj * arg);
extern obj vb_PERCENTILE (int narg, obj * arg);
extern obj vb_PERCENTRANK (int narg, obj * arg);
extern obj vb_PERMUT (int narg, obj * arg);
extern obj vb_POISSON (int narg, obj * arg);
extern obj vb_PROB (int narg, obj * arg);
extern obj vb_QUARTILE (int narg, obj * arg);
extern obj vb_RANK (int narg, obj * arg);
extern obj vb_RSQ (int narg, obj * arg);
extern obj vb_SKEW (int narg, obj * arg);
extern obj vb_SLOPE (int narg, obj * arg);
extern obj vb_SMALL (int narg, obj * arg);
extern obj vb_STANDARDIZE (int narg, obj * arg);
extern obj vb_STDEV (int narg, obj * arg);
extern obj vb_STDEVP (int narg, obj * arg);
extern obj vb_STEYX (int narg, obj * arg);
extern obj vb_TDIST (int narg, obj * arg);
extern obj vb_TINV (int narg, obj * arg);
extern obj vb_TREND (int narg, obj * arg);
extern obj vb_TRIMMEAN (int narg, obj * arg);
extern obj vb_TTEST (int narg, obj * arg);
extern obj vb_VAR (int narg, obj * arg);
extern obj vb_VARP (int narg, obj * arg);
extern obj vb_WEIBULL (int narg, obj * arg);
extern obj vb_ZTEST (int narg, obj * arg);

extern Fct statarrayfct[];










































































#endif 
