/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef TEXTFCT_H
#define TEXTFCT_H
#include "object.h"
#include "libfct.h"


extern obj vb_LEFT (int narg, obj * arg);
extern obj vb_RIGHT (int narg, obj * arg);
extern obj vb_MID (int narg, obj * arg);
extern obj vb_CONCATENATE (int narg, obj * arg);
extern obj vb_LEN (int narg, obj * arg);
extern obj vb_INSTR (int narg, obj * arg);
extern obj vb_RTRIM (int narg, obj * arg);
extern obj vb_LTRIM (int narg, obj * arg);
extern obj vb_TRIM (int narg, obj * arg);
extern obj vb_VALUE (int narg, obj * arg);
extern obj vb_FIXED (int narg, obj * arg);

extern Fct textarrayfct[];

#endif 
