/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef AXIS_VB_H
#define AXIS_VB_H
#include "axis.h"
#include "class.h"


extern obj vb_axis_settitle (int narg, obj * arg);
extern obj vb_axis_gettitle (int narg, obj * arg);
extern obj vb_axis_sethastitle (int narg, obj * arg);
extern obj vb_axis_gethastitle (int narg, obj * arg);
extern obj vb_axis_setminimumscale (int narg, obj * arg);
extern obj vb_axis_getminimumscale (int narg, obj * arg);
extern obj vb_axis_setmaximumscale (int narg, obj * arg);
extern obj vb_axis_getmaximumscale (int narg, obj * arg);
extern obj vb_axis_setminorunit (int narg, obj * arg);
extern obj vb_axis_getminorunit (int narg, obj * arg);
extern obj vb_axis_setmajorunit (int narg, obj * arg);
extern obj vb_axis_getmajorunit (int narg, obj * arg);
extern obj vb_axis_setmajorgridlines (int narg, obj * arg);
extern obj vb_axis_getmajorgridlines (int narg, obj * arg);
extern obj vb_axis_setminorgridlines (int narg, obj * arg);
extern obj vb_axis_getminorgridlines (int narg, obj * arg);


static Memberdata Axisdata[] =
{
  {"AxisTitle", TITLE, &vb_axis_settitle, &vb_axis_gettitle},
  {"HasTitle", BOOLEAN, &vb_axis_sethastitle, &vb_axis_gethastitle},
{"MinimumScale", DOUBLE, &vb_axis_setminimumscale, &vb_axis_getminimumscale},
{"MaximumScale", DOUBLE, &vb_axis_setmaximumscale, &vb_axis_getmaximumscale},
  {"Minorunit", DOUBLE, &vb_axis_setminorunit, &vb_axis_getminorunit},
  {"Majorunit", DOUBLE, &vb_axis_setmajorunit, &vb_axis_getmajorunit},
  {"HasMajorGridLines", BOOLEAN, &vb_axis_setmajorgridlines, &vb_axis_getmajorgridlines},
  {"HasMinorGridLines", BOOLEAN, &vb_axis_setminorgridlines, &vb_axis_getminorgridlines},
  {NULL, 0, NULL, NULL}
};

static Fct Axisfct[] =
{
  {NULL, NULL, 0, 0}
};



#endif 
