/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef BUTTON_VB_H
#define BUTTON_VB_H
#include "button.h"
#include "class.h"

extern obj vb_buttons_add (int narg, obj * arg);

extern obj vb_button_setonaction (int narg, obj * arg);
extern obj vb_button_getonaction (int narg, obj * arg);

extern obj vb_button_settext (int narg, obj * arg);
extern obj vb_button_gettext (int narg, obj * arg);


static Memberdata Buttonsdata[] =
{
  {NULL, 0, NULL, NULL}
};

static Fct Buttonsfct[] =
{
  {"Add", &vb_buttons_add, 4, BUTTON},
  {NULL, NULL, 0, 0}
};

static Memberdata Buttondata[] =
{
  {"OnAction", STRING_CONSTANT, &vb_button_setonaction, &vb_button_getonaction},
  {"Text", STRING_CONSTANT, &vb_button_settext, &vb_button_gettext},
  {NULL, 0, NULL, NULL}
};

static Fct Buttonfct[] =
{
  {NULL, NULL, 0, 0}
};


#endif 
