/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef CALLBACK_APPL_H
#define CALLBACK_APPL_H

#include <X11/Intrinsic.h>

void m_openfile (char *filename);
void m_newfile (Widget w, XtPointer client_data, XtPointer call_data);
void m_savefile (Widget w, XtPointer client_data, XtPointer call_data);
void m_saveasfile (char *filename);
void m_closefile (Widget w, XtPointer client_data, XtPointer call_data);
void m_printfile (Widget w, XtPointer client_data, XtPointer call_data);
void m_addsheet (Widget w, XtPointer client_data, XtPointer call_data);
void m_delsheet (Widget w, XtPointer client_data, XtPointer call_data);
void m_delline (Widget w, XtPointer client_data, XtPointer call_data);
void m_delcolumn (Widget w, XtPointer client_data, XtPointer call_data);
void m_insertcolumn (Widget w, XtPointer client_data, XtPointer call_data);
void m_insertline (Widget w, XtPointer client_data, XtPointer call_data);
void m_find (Widget w, XtPointer client_data, XtPointer call_data);
void m_replace (Widget w, XtPointer client_data, XtPointer call_data);
void m_goto (Widget w, XtPointer client_data, XtPointer call_data);
void m_changewin (Widget w, XtPointer client_data, XtPointer call_data);



#endif 
