/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/



























#include "param.h"

#define RET_NONE 0
#define RET_OK  2
#define RET_CANCEL 3

typedef struct
  {
    Widget Dialog;
    Widget Shell;
    void (*function) ();
    Widget parent;
    Widget message;
    Widget input;
    Widget cancel;
    Widget ok;
  }
InputBox;



extern char *inputbox (char *message, char *titre, char *def);


extern void
  CreateInputBox (Widget parent, char *titre, char *def);

extern void
  InputBox_CancelAction (Widget widget, XEvent * event, String * params, Cardinal * num_params);

extern void
  InputBox_AcceptAction (Widget widget, XEvent * event, String * params, Cardinal * num_params);

extern void
  cb_InputBox_Cancel (Widget widget, XtPointer closure, XtPointer call_data);

extern void
  cb_InputBox_Accept (Widget widget, XtPointer closure, XtPointer call_data);


extern void
  InputBox_Display (Widget centerw);
