/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef GRAM_EXT_H
#define GRAM_EXT_H
#include "object.h"

extern obj mkassign (obj o1, obj o2);
extern obj mksumassign (obj o1, obj o2);
extern obj mkuminus (obj o1);
extern obj mkplusplus (obj o1);
extern obj mkminusminus (obj o1);
extern obj mksum (obj o1, obj o2);
extern obj mkdiff (obj o1, obj o2);
extern obj mkmult (obj o1, obj o2);
extern obj mkdiv (obj o1, obj o2);
extern obj mkmod (obj o1, obj o2);
extern obj mkintdiv (obj o1, obj o2);
extern obj mkpow (obj o1, obj o2);
extern obj mklt (obj o1, obj o2);
extern obj mkgt (obj o1, obj o2);
extern obj mkge (obj o1, obj o2);
extern obj mkle (obj o1, obj o2);
extern obj mkne (obj o1, obj o2);
extern obj mkeq (obj o1, obj o2);
extern obj mkor (obj o1, obj o2);
extern obj mkand (obj o1, obj o2);
extern obj mkxor (obj o1, obj o2);
extern obj mkconcat (obj o1, obj o2);
extern obj mknot (obj o1);



#endif 
