/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef SELECTION_H
#define SELECTION_H
#include "stdio.h"
#include "object.h"



#define SEL_END -1

struct _Selection
  {
    obj *objects;
    int objnum;
    int ret;
  };

typedef struct _Selection Selection;

extern Selection *ActiveSelection;

Selection *newselection ();
int freeselection (Selection * sel);
int selection_addobj (Selection * sel, obj o);
int selection_reset (Selection * sel);
obj selection_getobjects (Selection * sel);
int selection_resetget (Selection * sel);
int selection_print (Selection * sel);
#endif 
