/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef APPLICATION_VB_H
#define APPLICATION_VB_H
#include "application.h"
#include "class.h"

extern obj vb_application_setactiveworkbook (int narg, obj * arg);
extern obj vb_application_getactiveworkbook (int narg, obj * arg);
extern obj vb_application_setactiveworksheet (int narg, obj * arg);
extern obj vb_application_getactiveworksheet (int narg, obj * arg);
extern obj vb_application_setactivecell (int narg, obj * arg);
extern obj vb_application_getactivecell (int narg, obj * arg);
extern obj vb_application_getthisworkbook (int narg, obj * arg);
extern obj vb_application_setthisworkbook (int narg, obj * arg);
extern obj vb_application_getscreenupdating (int narg, obj * arg);
extern obj vb_application_setscreenupdating (int narg, obj * arg);

extern obj vb_application_quit (int narg, obj * arg);
extern obj vb_application_calculate (int narg, obj * arg);


static Memberdata Applicationdata[] =
{
  {"ActiveWorkbook", WORKBOOK, &vb_application_setactiveworkbook, &vb_application_getactiveworkbook},
  {"ActiveCell", CELL, &vb_application_setactivecell, &vb_application_getactivecell},
  {"ActiveWorksheet", WORKSHEET, &vb_application_setactiveworksheet, &vb_application_getactiveworksheet},
  {"Thisworkbook", WORKBOOK, &vb_application_setthisworkbook, &vb_application_getthisworkbook},
  {"ScreenUpdating", INTEGER, &vb_application_setscreenupdating, &vb_application_getscreenupdating},
  {NULL, 0, NULL, NULL}
};

static Fct Applicationfct[] =
{
  {"Quit", &vb_application_quit, INTEGER, 0},
  {"Calculate", &vb_application_calculate, INTEGER, 0},
  {NULL, NULL, 0, 0}
};


#endif 
