/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/



























#include "axis_vb.h"
#include "application.h"
#include "libfct.h"

obj
vb_axis_settitle (narg, arg)
     int narg;
     obj *arg;
{
  obj o = arg[0];

  return o;
}

obj
vb_axis_gettitle (narg, arg)
     int narg;
     obj *arg;
{
  obj o;
  Axis *ax = (Axis *) arg[0].rec.s;


  o.type = TITLE;
  o.label = arrayclass[TITLE].name;
  o.rec.s = (char *) &(ax->AxisTitle);
  return o;
}

obj
vb_axis_sethastitle (narg, arg)
     int narg;
     obj *arg;
{
  obj o = arg[1];
  obj *axisobj = (obj *) arg[0].rec.s;
  Axis *axis = (Axis *) axisobj->rec.s;
  axis->HasTitle = obj2int (arg[1]);
  return o;
}

obj
vb_axis_gethastitle (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}

obj
vb_axis_setminimumscale (narg, arg)
     int narg;
     obj *arg;
{
  obj o = arg[1];
  obj *axisobj = (obj *) arg[0].rec.s;
  Axis *axis = (Axis *) axisobj->rec.s;
  axis->MinimumScale = obj2double (arg[1]);
  axis->MinimumScaleIsAuto = 0;
  return o;
}

obj
vb_axis_getminimumscale (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}

obj
vb_axis_setmaximumscale (narg, arg)
     int narg;
     obj *arg;
{
  obj o = arg[1];
  obj *axisobj = (obj *) arg[0].rec.s;
  Axis *axis = (Axis *) axisobj->rec.s;
  axis->MaximumScale = obj2double (arg[1]);
  axis->MaximumScaleIsAuto = 0;
  return o;
}

obj
vb_axis_getmaximumscale (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}

obj
vb_axis_setminorunit (narg, arg)
     int narg;
     obj *arg;
{
  obj o = arg[1];
  obj *axisobj = (obj *) arg[0].rec.s;
  Axis *axis = (Axis *) axisobj->rec.s;
  axis->MinorUnit = obj2double (arg[1]);
  axis->MinorUnitIsAuto = 0;
  return o;
}

obj
vb_axis_getminorunit (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}

obj
vb_axis_setmajorunit (narg, arg)
     int narg;
     obj *arg;
{
  obj o = arg[1];
  obj *axisobj = (obj *) arg[0].rec.s;
  Axis *axis = (Axis *) axisobj->rec.s;
  axis->MajorUnit = obj2double (arg[1]);
  axis->MajorUnitIsAuto = 0;
  return o;
}

obj
vb_axis_getmajorunit (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}

obj
vb_axis_setmajorgridlines (narg, arg)
     int narg;
     obj *arg;
{
  obj o = arg[1];
  obj *axisobj = (obj *) arg[0].rec.s;
  Axis *axis = (Axis *) axisobj->rec.s;
  axis->HasMajorGridLines = obj2int (arg[1]);
  return o;
}

obj
vb_axis_getmajorgridlines (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}

obj
vb_axis_setminorgridlines (narg, arg)
     int narg;
     obj *arg;
{
  obj o = arg[1];
  obj *axisobj = (obj *) arg[0].rec.s;
  Axis *axis = (Axis *) axisobj->rec.s;
  axis->HasMinorGridLines = obj2int (arg[1]);
  return o;
}

obj
vb_axis_getminorgridlines (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}
