/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/





























#include "font_vb.h"
#include "cell.h"

#include "libfct.h"


obj
vb_font_setbold (narg, arg)
     int narg;
     obj *arg;
{
  obj o, font;			

  font = *(obj *) arg[0].rec.s;
  o = *(obj *) font.rec.s;

  switch (o.type)
    {
    case CELL:
      cell_fontbold ((Cell *) o.rec.s, obj2int (arg[1]));
      break;

    }
  return o;
}

obj 
vb_font_getbold (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}

obj 
vb_font_setitalic (narg, arg)
     int narg;
     obj *arg;
{
  obj o, font;			

  font = *(obj *) arg[0].rec.s;
  o = *(obj *) font.rec.s;

  switch (o.type)
    {
    case CELL:
      cell_fontitalic ((Cell *) o.rec.s, obj2int (arg[1]));
      break;
    }
  return o;

}

obj 
vb_font_getitalic (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}


obj
vb_font_setsize (narg, arg)
     int narg;
     obj *arg;
{
  obj o, font;			

  font = *(obj *) arg[0].rec.s;
  o = *(obj *) font.rec.s;

  switch (o.type)
    {
    case CELL:
      cell_fontsize ((Cell *) o.rec.s, obj2int (arg[1]));
      break;
    }
  return o;

}

obj 
vb_font_getsize (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}


obj 
vb_font_setname (narg, arg)
     int narg;
     obj *arg;
{
  obj o, font;			

  font = *(obj *) arg[0].rec.s;
  o = *(obj *) font.rec.s;

  switch (o.type)
    {
    case CELL:
      cell_fontname ((Cell *) o.rec.s, obj2string (arg[1]));
      break;
    }
  return o;

}

obj 
vb_font_getname (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}


obj 
vb_font_setcolorindex (narg, arg)
     int narg;
     obj *arg;
{
  obj o, font;			

  font = *(obj *) arg[0].rec.s;
  o = *(obj *) font.rec.s;

  switch (o.type)
    {
    case CELL:
      cell_setfg ((Cell *) o.rec.s, obj2int (arg[1]));
      break;
    }
  return o;

}

obj 
vb_font_getcolorindex (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}



obj 
vb_font_assign (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}

obj 
vb_font_print (narg, arg)
     int narg;
     obj *arg;
{
  obj o;

  return o;
}
