/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef FONT_VB_H
#define FONT_VB_H
#include "class.h"
#include <stdlib.h>


extern obj vb_font_setbold (int narg, obj * arg);
extern obj vb_font_getbold (int narg, obj * arg);
extern obj vb_font_setitalic (int narg, obj * arg);
extern obj vb_font_getitalic (int narg, obj * arg);
extern obj vb_font_setname (int narg, obj * arg);
extern obj vb_font_getname (int narg, obj * arg);
extern obj vb_font_setsize (int narg, obj * arg);
extern obj vb_font_getsize (int narg, obj * arg);
extern obj vb_font_assign (int narg, obj * arg);
extern obj vb_font_setcolorindex (int narg, obj * arg);
extern obj vb_font_getcolorindex (int narg, obj * arg);
extern obj vb_font_print (int narg, obj * arg);


static Memberdata Fontdata[] =
{
  {"bold", BOOLEAN, &vb_font_setbold, &vb_font_getbold},
  {"italic", BOOLEAN, &vb_font_setitalic, &vb_font_getitalic},
  {"name", STRING, &vb_font_setname, &vb_font_getname},
  {"size", INTEGER, &vb_font_setsize, &vb_font_getsize},
  {"ColorIndex", INTEGER, &vb_font_setcolorindex, &vb_font_getcolorindex},
  {NULL, 0, NULL, NULL}
};

static Fct Fontfct[] =
{
  {"=", &vb_font_assign, CELL, 2},
  {"print", &vb_font_print, 0, 1},
  {NULL, NULL, 0, 0}
};



#endif 
