/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/



































































#define GRAPHITEMS   11		
#define GRAPHOPTIONS  5		
#define GRAPHTYPES    5		
#define GRAPHRANGES   7		
#define GRAPHRESETS   8		
#define GRAPHLEGENDS  6		
#define GRAPHFORMATS  7		
#define GRAPHSYMBOLS  4		
				
#define GRAPHTITLES   4		
#define GRAPHSCALES   3		
#define GRAPHXYSCALES 4		

char graphic_type;		
char graphic_legend[GRAPHLEGENDS][100];		
char graphic_format[GRAPHFORMATS];	
char graphic_title[GRAPHTITLES][50];	

char graphic_grid;		
				
char g_auto_man[2];		
				
unsigned int graphic_skip;	
unsigned int curves_n;

double graphic_scale[GRAPHSCALES - 1][2];	
						

struct g_range
  {
    char col[3];		
    int r1, r2, c;		
  };
struct g_range graphic_range[GRAPHRANGES];
