/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef FILESELECTOR_H
#define FILESELECTOR_H
Boolean IsDirectory (char *root, char *path);
int MakePrompt (Widget centerw, char *prompt, void (*func) (), char *def);
void remake_list ();
void freelist ();
void change_dir (Widget w, XtPointer closure, XtPointer call_data);
void MakeFullPath (char *root, char *filename, char *pathname);
void set_filename (Widget w, XtPointer closure, XtPointer call_data);
Widget gettop ();

void cb_Accept (Widget w, XtPointer client_data, XtPointer call_data);
void AcceptAction (Widget widget, XEvent * event, String * params, Cardinal * num_params);

void cb_Cancel (Widget w, XtPointer client_data, XtPointer call_data);
void CancelAction (Widget widget, XEvent * event, String * params, Cardinal * num_params);

void cb_Rescan (Widget w, XtPointer client_data, XtPointer call_data);
void RescanAction (Widget widget, XEvent * event, String * params, Cardinal * num_params);

#endif 
